mod Ex12

incl Mtex

incl Mtexa

loc rem 
  \para \bf  12. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end utorok 16.5.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0506ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane poliam. 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor \it  ex12.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Arrays.  \end 

rem 
  \para \bf  Section. Formalization of Arrays.  \end 

rem 
  \para \bf  Subsection. Basic Operations.  \end 

rem 
  \para \bf  Arrays.  \end 

pred/2 A 'Tex_p2_a_array'
  A(n,a) <-> Poo

rem 
  \para \bf  Array subscription.  \end 

fun/2 Sub 'Tex_f2_a_sub'
  Sub(a,i) = Foo

rem 
  \para \bf  Array modification.  \end \header* fun/3 Msub 'Tex_f3_a_msub' \end 
  Specification: 
  \eq* 
    A(n,a) & i < n -> A(n,Msub(a,i,x))
  \end
  \eq* 
    A(n,a) & i < n -> Sub(Msub(a,i,x),i) = x
  \end
  \eq* 
    A(n,a) & i < n & j < n & j != i -> Sub(Msub(a,i,x),j) = Sub(a,j)
  \end

fun/3 Msub 'Tex_f3_a_msub'
  Msub(a,i,x) = Foo

rem 
  \para \bf  New array.  \end Specification: 
  \eq* 
    A(n,New(n))
  \end

fun New 
  New(n) = Foo

rem 
  \para \bf  Subsection. Additional Operations.  \end 

rem 
  \para \bf  Concatenation.  \end \header* fun/2 Conc 'Tex_f2_a_conc' \end 
  Specification: 
  \eq* 
    A(m,a) & A(n,b) -> A(m+n,Conc(a,b))
  \end
  \eq* 
    A(m,a) & A(n,b) & i < m -> Sub(Conc(a,b),i) = Sub(a,i)
  \end
  \eq* 
    A(m,a) & A(n,b) & i < n -> Sub(Conc(a,b),i+m) = Sub(b,i)
  \end

fun/2 Conc 'Tex_f2_a_conc'
  Conc(a,b) = Foo

rem 
  \para \bf  [CL] Remark.  \end Note that the concatenation function is builtin 
  in CL. 

rem 
  \para \bf  Subarrays.  \end \header* fun/3 Sba 'Tex_f3_a_sba' \end 
  Specification: 
  \eq* 
    A(n,a) & k <= m & m <= n -> A(m-k,Sba(a,k,m))
  \end
  \eq* 
    A(n,a) & k <= m & m <= n & k+i < m -> Sub(Sba(a,k,m),i) = Sub(a,k+i)
  \end

fun/3 Sba 'Tex_f3_a_sba'
  Sba(a,k,m) = Foo

rem 
  \para \bf  Array membership.  \end 

pred/3 Ina 'Tex_p3_a_in'
  Ina(x,n,a) <-> Poo

rem 
  \para \bf  Ordered arrays.  \end 

pred/2 Ord 'Tex_p2_a_ord'
  Ord(n,a) <-> Poo

rem 
  \para \bf  Permutation of arrays.  \end 

fun/2 Eqf 'Tex_f2_char_eqf'
  Eqf(x,y) = 1 <- x = y
  Eqf(x,y) = 0 <- x != y

fun/3 Count 
  Count(x,0,a) = 0
  Count(x,i+1,a) = Count(x,i,a)+Eqf(x,Sub(a,i))

pred/3 Perm 'Tex_p3_a_perm'
  Perm(n,a,b) <-> \a x Count(x,n,a) = Count(x,n,b)

rem 
  \para \bf  Section. Programming with Arrays.  \end 

rem 
  \para \bf  Swapping two elements.  \end 
  \header* fun/3 Swap 'Tex_f3_a_swap' \end Define the function 
  \ft Swap(a,i,j) \end such that 
  \eq* 
    A(n,a) & i < n & j < n -> A(n,Swap(a,i,j))
  \end
  \eq* 
    A(n,a) & i < n & j < n -> Sub(Swap(a,i,j),i) = Sub(a,j)
  \end
  \eq* 
    A(n,a) & i < n & j < n -> Sub(Swap(a,i,j),j) = Sub(a,i)
  \end
  \eq* 
    A(n,a) & i < n & j < n & k < n & k != i & k != j -> 
    Sub(Swap(a,i,j),k) = Sub(a,k)
  \end

fun/3 Swap 'Tex_f3_a_swap'
  Swap(a,i,j) = Foo

rem 
  \para \bf  Filling an array.  \end \header* fun/3 Fill  \end Define the 
  function \ft Fill(n,a,x) \end such that 
  \eq* 
    A(n,a) -> A(n,Fill(n,a,x))
  \end
  \eq* 
    A(n,a) & i < n -> Sub(Fill(n,a,x),i) = x
  \end
  \para \it  Hint.  \end \header* fun/4 Fill1 'Tex_f4_f' \end Define first an 
  auxiliary function \ft Fill1(k,n,a,x) \end satisfying the following invariant: 
  \eq* 
    A(n,a) & k <= n -> Fill1(k,n,a,x) = Sba(a,0,k)++Fill(n-k,Sba(a,k,n),x)
  \end

fun/4 Fill1 'Tex_f4_f'
  Fill1(k,n,a,x) = Foo

fun/3 Fill 
  Fill(n,a,x) = Foo

rem 
  \para \bf  Binary search.  \end \header* pred/3 Bsearch  \end Find an 
  efficient implementation of the array membership predicate for ordered arrays. 
  That is, define the predicate \ft Bsearch(x,n,a) \end such that 
  \eq* 
    A(n,a) & Ord(n,a) -> Bsearch(x,n,a) <-> Ina(x,n,a)
  \end
  \para \it  Hint.  \end \header* pred/4 Bsearch1 'Tex_p4_p' \end Define first 
  an auxiliary predicate \ft Bsearch1(x,k,m,a) \end such that 
  \eq* 
    A(n,a) & Ord(n,a) & k <= m & m <= n -> Bsearch1(x,k,m,a) <-> 
    Ina(x,m-k,Sba(a,k,m))
  \end
  \para Note that the condition of regularity follows from 
  \eq* 
    k < m -> k <= (k+m)/2 & (k+m)/2 < m
  \end

pred/4 Bsearch1 'Tex_p4_p'
  Bsearch1(x,k,m,a) <-> Poo

pred/3 Bsearch 
  Bsearch(x,n,a) <-> Poo

rem 
  \para \bf  The Dutch national flag problem.  \end Let 
  \def 
    pred/2 Red 'Tex_p2_a_red'
    Red(n,a) <-> \a i(i < n -> Sub(a,i) = 0)
  \end
  \def 
    pred/2 White 'Tex_p2_a_white'
    White(n,a) <-> 
      \a i(i < n -> Sub(a,i) = 1)
  \end
  \def 
    pred/2 Blue 'Tex_p2_a_blue'
    Blue(n,a) <-> 
      \a i(i < n -> Sub(a,i) >= 2)
  \end
  \def 
    pred/2 Dnf 'Tex_p2_a_dnf'
    Dnf(n,a) <-> 
      \e r\e b(r <= b & b <= n & Red(r,Sba(a,0,r)) & White(b-r,Sba(a,r,b)) & 
               Blue(n-b,Sba(a,b,n)))
  \end
  \para \header* fun/2 Dsort  \end Define the function \ft Dsort(n,a) \end such 
  that 
  \eq* 
    A(n,a) -> A(n,Dsort(n,a))
  \end
  \eq* 
    A(n,a) -> Perm(n,Dsort(n,a),a)
  \end
  \eq* 
    A(n,a) -> Dnf(n,Dsort(n,a))
  \end
  \para \it  Hint.  \end \header* fun/4 Dsort1 'Tex_f4_f' \end Define first an 
  auxiliary function \ft Dsort1(a,r,w,b) \end such that 
  \eq* 
    A(n,a) & r <= w & w <= b & b <= n -> A(n,Dsort1(a,r,w,b))
  \end
  \eq* 
    A(n,a) & r <= w & w <= b & b <= n -> Perm(n,Dsort1(a,r,w,b),a)
  \end
  \eq* 
    A(n,a) & r <= w & w <= b & b <= n & Red(r,Sba(a,0,r)) & 
    White(w-r,Sba(a,r,w)) & Blue(n-b,Sba(a,b,n)) -> Dnf(n,Dsort1(a,r,w,b))
  \end

fun/4 Dsort1 'Tex_f4_f'
  Dsort1(a,r,w,b) = Foo

fun/2 Dsort 
  Dsort(n,a) = Foo

rem 
  \para \bf  Quicksort.  \end \header* fun/2 Qsort  \end Implement the quicksort 
  algorithm. That is, define the function \ft Qsort(n,a) \end such that 
  \eq* 
    A(n,a) -> A(n,Qsort(n,a))
  \end
  \eq* 
    A(n,a) -> Perm(n,Qsort(n,a),a)
  \end
  \eq* 
    A(n,a) -> Ord(n,Qsort(n,a))
  \end
  \para \it  Hint.  \end \header* fun/3 Qsort1 'Tex_f3_f' \end Define first an 
  auxiliary function \ft Qsort1(a,k,m) \end satisfying the following invariant: 
  \eq* 
    A(n,a) & k <= m & m <= n -> 
    Qsort1(a,k,m) = Sba(a,0,k)++Qsort(m-k,Sba(a,k,m))++Sba(a,m,n)
  \end

fun/5 Pt 'Tex_f5_partition'
  Pt(a,r,w,b,p) = Foo

fun/3 Qsort1 'Tex_f3_f'
  Qsort1(a,k,m) = Foo

rem 
  \para Note that we have 
  \eq* 
    Pt(a,r,w,b,p) = a1,r1,b1 -> r <= r1 & b1 <= b
  \end
  \eq* 
    r < w & w <= b & Pt(a,r,w,b,p) = a1,r1,b1 -> r1 < b1
  \end
  \para Therefore 
  \eq* 
    k < m & Pt(a,k,k+1,m,Sub(a,k)) = a1,r,b -> k <= r & r < b & b <= m
  \end
  \para This proves the conditions of regularity for \ft Qsort1(a,k,m) \end. 

fun/2 Qsort 
  Qsort(n,a) = Foo

